# sysadmin.pl
# Perl Library
# some common functions that don't need to be rewritten over and over
# in the Perl utilities
#
# becareful not to use any possible global varibles in other perl scripts
#
#
# $Header: /kees/projects/gsh/RCS/sysadmin.pl,v 1.13 2000/06/26 07:32:01 nemesis Exp $
#
# Copyright (C) 1998,1999,2000 Cornelius Cook, Paul Holcomb
# cook@cpoint.net, http://outflux.net/
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# http://www.gnu.org/copyleft/gpl.html
#

$ENV{'PATH'}="/usr/local/bin:/usr/local/sbin:/usr/bin:/bin:/usr/sbin:/sbin";

#figure out where rsh is
($SYSADM_RSH)=
  grep(-x $_,("/usr/bin/rsh","/bin/rsh","/usr/bin/remsh","/bin/remsh"));
#print "rsh: $SYSADM_RSH\n";

# figure out where sendmail is
($SYSADM_MAIL_PROG)=
  grep(-x $_,("/usr/ucblib/sendmail","/usr/sbin/sendmail","/usr/lib/sendmail"));
#print "Mailer: $SYSADM_MAIL_PROG\n";

$SYSADM_MAIL="/usr/bin/mailx";

#figure out where mt is
($SYSADMIN_MT)=grep(-x $_,("/bin/mt","/usr/ucb/mt","/usr/bin/mt"));
#print "mt: $SYSADM_MT\n";

#figure out where cpio is
($SYSADM_CPIO)=grep(-x $_,("/bin/cpio","/usr/ucb/cpio","/usr/bin/cpio"));
#print "cpio: $SYSADM_CPIO\n";

#figure out where sendpage is
# default to /sysadmin/bin/sendpage if the other is not found.
$SYSADM_SENDPAGE="/sysadmin/bin/sendpage -n";
$SYSADM_SENDPAGE="/proj/pager/bin/sendpage -n" if (-x "/proj/pager/bin/sendpage");

$SYSADM_SENDPAGE_HOST="sendpage";

#figure out who I am
chop($SYSADM_HOST=`/bin/uname -n`);
$SYSADM_HOST=~s/\..*$//;

$SYSADM_SYSINFO = "/sysadmin/etc/sysinfo";
$SYSADM_CAT = "/bin/cat -s";
$SYSADM_PAGER_NAME="pager";		# name of the pager user
$SYSADM_GHOSTS_NAME="/etc/ghosts";	# name of machine list
$SYSADM_ONCALL_NAME="/ref/Misc/Oncall/schedule";# default place to find oncall
@SYSADM_ONCALL_DEFAULT=(
"FIRST_NAME LAST_NAME PAGER HOME OFFICE");      # default people oncall
undef @NOW_ONCALL;				# we haven't loaded the oncall
#@sysadm_ghosts has all the valid lines after "LoadGhosts"
#@BACKBONES is the list of all machine you want to do something to

# loads the ghosts file into @sysadmin_ghosts
sub LoadGhosts {
	local($file) = @_;
	local($line);
	$file=$SYSADM_GHOSTS_NAME if (!$file || $file eq "");
	open(SYSADM_GHOSTS_FILE,"<${file}") ||
		warn("$0: Cannot open \"${file}\": $!\n");
	while (<SYSADM_GHOSTS_FILE>) {
		# kill blank lines
		s/[ \t]*\n//;
		$line = $_;
		# kill commented or blank lines
		if ($line ne "" && $line !~ /^#/) {
			push(@sysadm_ghosts,$line);
		}
	}
	close(SYSADM_GHOSTS_FILE);
}

sub CheckGhostFor {
	local($machine,$what) = @_;
	local(@result,$list);

	@result=&ParseGhosts(0,$what);
	$list=":".join(":",@result).":";

#	print "$what ($machine) sees $list\n";

	return 1 if ($list =~ /:$machine:/);
	return 0;
}

sub ParseGhosts {
	my($depth,@what) = @_;
	my($one_of_these,$name,$repl,$host,$wanted,@attr,$line,@repl,@query);

	if ($depth>10) {
		print STDERR "ParseGhosts: recurrsive macro?  Depth == 10 at '$what'\n";
		return ("");
	}

	# if no argument, match all machine names
	@what = ("all") if (!@what);

	# make the starting matching string, ":" separated
	$one_of_these = ":" . join("+",@what) . ":";     # prepare to expand "macros"
	$one_of_these =~ s/\+/:/g;           # we hope to end up with list of
	$one_of_these =~ s/-/:-/g;           #  colon separated attributes
	$one_of_these =~ s/:+/:/g;

#	warn "ParseGhosts[$depth]: expanding '$one_of_these'\n";
	undef @repl;
	LoadGhosts() if (!defined(@sysadm_ghosts));
	foreach $line (@sysadm_ghosts) {           # for each line of ghosts
		if ($line =~ /^(\w+)=(.+)/) {         # a macro line?
        		$name = $1; $repl = $2;
        		$repl =~ s/\+/:/g;	# make an addition
		        $repl =~ s/-/:-/g;	# subtract
    			# do expansion in "wanted" list
        		if ($one_of_these =~ /:$name:/) {
				@query = &ParseGhosts($depth+1,$repl);
				$repl = ":" . join(":",@query) . ":";
#				warn "'$one_of_these' matched '$name' as '$repl'\n";
        			$one_of_these =~ s/:$name:/:$repl:/;
			}
				
			# do expansion in "unwanted" list
        		if ($one_of_these =~ /:-$name:/) {
				@query = &ParseGhosts($depth+1,$repl);
				$repl = ":" . join(":",@query) . ":";
			        $repl =~ s/:/:-/g;
#				warn "'$one_of_these' matched '-$name' as '$repl'\n";
		        	$one_of_these =~ s/:-$name:/:$repl:/;
			}
		}
		else {
			# we have a normal line
	
    			@attr = split(' ',$line);# a list of attributes to match against
                        #   which we put into an array
		    	$host = $attr[0];       # the first attribute is the host name
	
			$wanted = 0;
    			foreach $attr (@attr) { # iterate over attribute array
       		 		if (index($one_of_these,":$attr:") >= 0) {
	       		 		$wanted++;
				}
       		 		if (index($one_of_these,":-$attr:") >= 0) {
       		 			$wanted = 0;
					last;
				}
    			}
			push(@repl,$host) if ($wanted > 0);
		}
	        next;
	}
	@repl;
}

# sets the BACKBONES variable depending on argument
sub SetBACKBONES {
	local(@type) = @_;
	undef @BACKBONES;		# clear backbone list
	@BACKBONES=&ParseGhosts(0,@type);
}

# unsets machines from the BACKBONE list, based on argument
sub UnSetBACKBONES {
	local(@these) = @_;

	# join list
	$sysadm_tmp = join(' ',@BACKBONES);
	# for each argument...
	foreach $sysadm_machine (@these) {
		# ...drop any matching machine name
		$sysadm_tmp =~ s/\b${sysadm_machine}\b//ig;
	}
	# recombine the BACKBONE list
	@BACKBONES = split(/\s+/,$sysadm_tmp);
}

# convert text days to ctime number
sub DayToNum {
	local($str) = @_;
	local(%day_list);
	%day_list = ("Mon", 0, "Tue", 1, "Wed", 2, "Thu", 3, "Fri", 4,
		     "Sat", 5, "Sun", 6);

	$day_list{$str};
}

# convert ctime day nums to text
sub NumToDay {
	local($num) = @_;
	local(@day_list);
	@day_list = ("Mon","Tue","Wed","Thu","Fri","Sat","Sun");

	$day_list[$num];
}

# convert a month abbreviation to a number 0 = Jan
sub MonToNum {
	local($str) = @_;
	local(%mon_list);
	%mon_list = ("jan",0,"feb",1,"mar",2,"apr",3,"may",4,"jun",5,
		     "jul",6,"aug",7,"sep",8,"oct",9,"nov",10,"dec",11);

	$str=substr($str,0,3);
	$str=~tr/A-Z/a-z/;
	$mon_list{$str};
}

# convert a number to a month abbreviation Jan = 0
sub NumToMon {
	local($num) = @_;
	local(@mon_list);
	@mon_list = ("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug",
		     "Sep","Oct","Nov","Dec");
	$num += 0;

	$mon_list[$num];
}

# right now this is inaccurate, and can only be used to compare similar
# style dates
sub TimeToSec {
	local($year,$mon,$day,$hour,$sec) = @_;
	$year+=0;
	$mon+=0;
	$day+=0;
	$hour+=0;
	$sec+=0;

	# I want to use reversed &ctime()
	$sec + ($min*60) + ($hour+3600) + ($day*86400) + ($mon*2764800) + 
		($year*35942400);
}

sub ValidDate {
	local($day,$mon,$yr)=@_;
	local(@days);
	return undef if ($yr<0);
	return undef if ($mon<0 || $mon>11);
	$yr += 100 if ($yr<90);
	$yr += 1900 if ($yr<190);
	# number of days per month
	@days = (31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
	#adjust feb days for leap year
	$days[1] += 1 if ($yr % 400 == 0 || ($yr % 4 == 0  && $yr % 100 != 0));
	return undef if ($day<1 || $day>$days[$mon]);
	return 1;
}

# parses the oncall list and returns @oncall(Facilities,Hardware,Sysadmin)
sub ParseOncall {
   local($filetouse,$debug) = @_;

   # did we already load it?
   if (!defined(@NOW_ONCALL)) {

	local(%oncall,@lines,$line,@result);
	local($name,$lastname,$lnum);
	local($oday,$omon,$oyear,$tday,$tmon,$tyear);
	local($sec,$min,$hour,$mday,$mon,$year,$undef,$undef,$undef)
		= localtime(time);

	print "Now is $mday/$mon/$year\n" if ($debug);

	undef $tday;
	undef $tmon;
	undef $tyear;
	undef @result;
	undef %oncall;

	# what file should it be loaded from?
	$filetouse = $SYSADM_ONCALL_NAME if (!defined($filetouse));

	if (!open(SYSADM_ONCALL_FILE,$filetouse)) {
		# yell about a bad oncall file
		warn "Error reading $filetouse: $!\n";
	}
	else {
		@lines = <SYSADM_ONCALL_FILE>;
		close(SYSADM_ONCALL_FILE);
		$lnum=0;
		SYSADM_PARSEONCALL_LOOP:
		foreach $line (@lines) {
			$lnum++;
			# ignore the useless lines
			next if ($line =~ /(^#|^\s*$|^Monday|^\s*[-]*\s*$|facilities|hardware|sysadmin)/i);
			print $line if ($debug);
			# is this the list of staffers?
			if ($line =~ /^(Sv|)\s+((\S+)\s+(\S+))\s+(\d+-\d+)\s+(\d+-\d+)\s+(\d+-\d+)$/) {
				# remember their name and phone numbers
				$name = "$2 $5 $6 $7";
				$lastname = $4;
				$oncall{$lastname} = $name;
				print "Adding '$name' under '$lastname'\n"
					if ($debug);
			}
			# is this a date/oncall person line?
			elsif ($line =~ /^(\d+)\/(\S+)\/(\d+)\s+(\S+)\s+(\S+)\s+(\S+)/) {
				if (!defined(%oncall)) {
					warn "Cannot find anyone available for oncall by the time line $lnum of $filetouse was read!\n";
					last SYSADM_PARSEONCALL_LOOP;
				}
				$oday = $1;
				$omon  = $2;
				$oyear = $3;
				$facil = $4;
				$hard  = $5;
				$sys   = $6;

				$omon = &MonToNum($omon);
				if (!defined($omon)) {
					warn "Bad month '$2' on line $lnum of $filetouse!\n";
					next;
				}

				if (!&ValidDate($oday,$omon,$oyear)) {
					warn "Not a real date: day $oday month ".($omon+1)." year $oyear!\n";
					next;
				}
				if ($tday != $oday || $tmon != $omon ||
				    $tyear != $oyear) {
					warn "Day $tday Month ".($tmon+1)." Year $tyear never defined at line $lnum of $filetouse!\n"
						if (defined($tday));
				}
				$tday=$oday+1;
				$tmon=$omon;
				$tyear=$oyear;
				if (!&ValidDate($tday,$tmon,$tyear)) {
					$tday=1;
					$tmon++;
				}
				if (!&ValidDate($tday,$tmon,$tyear)) {
					$tmon=0;
					$tyear++;
				}
				if (!&ValidDate($tday,$tmon,$tyear)) {
					warn "Cannot calculate tomorrow past day $oday month ".($omon+1)." year $oyear!\n";
					undef $tday;
				}

				if (!defined($oncall{$facil})) {
					warn "'$facil' does not have an oncall entry in Facilities staff area! (line $lnum of $filetouse)\n";
					next;
				}
				if (!defined($oncall{$hard})) {
					warn "'$hard' does not have an oncall entry in Hardware staff area! (line $lnum of $filetouse)\n";
					next;
				}
				if (!defined($oncall{$sys})) {
					warn "'$sys' does not have an oncall entry in Sysadmin staff area! (line $lnum of $filetouse)\n";
					next;
				}

				print "$facil $hard $sys oncall for $oday/$omon/$oyear\n"
					if ($debug);

				# is this today's date?
				if ($oday == $mday && $omon == $mon &&
					$oyear == $year) {
						# we found our oncall person!
						@result = ($oncall{$facil},$oncall{$hard},$oncall{$sys});
				}
			}
			else {
				# yell about bad formatting in the file
				print "Bad line number $lnum in $filetouse:\n$line";
			}
		}
	}
	if (!defined(@result)) {
		# hmm... something went wrong: better use default oncall eople
		@result = @SYSADM_ONCALL_DEFAULT;
		print "Error parsing oncall list.  Using supervisors by default.\n";
	}

	@NOW_ONCALL = @result;
   }
   # return result
   @NOW_ONCALL;
}

# converts a full name into an email account name
sub NameToEmail {
	local($who) = @_;

	# for now I'm just making the spaces into underscores
	$who =~ s/ /_/g;

#	local(@parts);
#
#	if ($who =~ / /) {
#		@parts = split(' ',$who);
#		$who = substr($parts[0],0,1) . substr($parts[1],0,7);
#	}
#	else {
#		$who = substr($who,0,8);
#	}

	$who;
}

sub SendMail {
	local($sendto,$subject,$message) = @_;

	open(MAIL,"| $SYSADM_MAIL_PROG -fnobody $sendto") ||
		warn "$0:  Can't spawn sendmail: $!\n";

	# send the mail
	print MAIL "To: $sendto
From: Automatic SysAdmin Tool <sysadmin\@$SYSADMIN_HOST>
Subject: $subject

$message\n";
	close MAIL;
}

# send a page to people using predator, not zigzag
sub Page2 {
	local($msg,@who) = @_;

	# open sendmail but with a "from nobody" so root doesn't get
	#  confirmation email
        open(MAIL, "| $SYSADM_MAIL_PROG -fnobody ${SYSADM_PAGER_NAME}2") ||
		warn "$0: Can't spawn sendmail: $!\n";

	# send the page
        print MAIL "To: ${SYSADM_PAGER_NAME}2
From: sysadmin.pl\@predator ($0)
Subject: @who

$msg\n";
	close(MAIL);
}

# send a page to people
sub Page {
	local($msg,@who) = @_;

	# open sendmail but with a "from nobody" so root doesn't get
	#  confirmation email
        open(MAIL, "| $SYSADM_MAIL_PROG -fnobody $SYSADM_PAGER_NAME") ||
		warn "$0: Can't spawn sendmail: $!\n";

	# send the page
        print MAIL "To: $SYSADM_PAGER_NAME
From: sysadmin.pl\@predator ($0)
Subject: @who

$msg\n";
	close(MAIL);
}
# send a page to people

#P.Holcomb 
# send a page using sendpage.
# if on a machine in GHOSTS pager, then send the page with sendpage
# if on leary, send the page with rsh to sendpage
# if on neither of these machines, mail to pager
sub SPage {
	local($msg,$who) = @_;

	#convert commas to spaces for compatibility
	$who =~ s/,/ /g;

	# check to see if machine has a pager connected it by checking filed in ghosts
	&LoadGhosts();
#	&SetBACKBONES("pager");
# 
#	if (grep (/\b$SYSADM_HOST\b/, @BACKBONES))  {
	if (&CheckGhostFor($SYSADM_HOST,"pager")) {
	    open(PAGE, "| $SYSADM_SENDPAGE $who >/dev/null") ||
		warn "$0: Can't spawn sendpage: $!\n";

	    # send the page
	    print PAGE "$msg\n";
	    close (PAGE);
	} elsif ($SYSADM_HOST eq "leary") {
	    open(PAGE, "| $SYSADM_RSH $SYSADM_SENDPAGE_HOST \"$SYSADM_SENDPAGE $who >/dev/null \"")
		|| warn "$0: Can't spawn rsh sendpage: $!\n";
	    
	    # send the page
	    print PAGE "$msg\n";
	    close (PAGE);
	} else {
	    # open sendmail but with a "from nobody" so root doesn't get
	    #  confirmation email
        open(MAIL, "| $SYSADM_MAIL_PROG -fnobody $SYSADM_PAGER_NAME") ||
		warn "$0: Can't spawn sendmail: $!\n";

	# send the page
	    print MAIL "To: $SYSADM_PAGER_NAME
From: sysadmin.pl\@mailhost ($0)
Subject: $who

$msg\n";
	close(MAIL);
}
    }
	

# figures out the backup device from a machine's sysinfo file
sub BackupDevice {
	local(@args) = @_;
	local($machine,$device,$dev,$RSH);

	$machine = $SYSADM_HOST;

	while (@args) {
		# which backup device from which machine do we want?
		$device = shift @args;
		if ($device !~ /^\d+$/) {
			$machine = $device;
			$device = shift @args;
		}
	}
	# default to "1"
	$device = 1 if (!$device);

	# are we the machine we want to rsh to?
	$RSH = "";
	$RSH = "/bin/rsh $machine -n " if ($machine ne $SYSADM_HOST);

	# dump the sysinfo file from that machine
	open(FILE,"${RSH}${SYSADM_CAT} ${SYSADM_SYSINFO}|");
	# get the device line
	($dev) = grep(/^\tDUMP_TAPE${device}/,<FILE>);
	close(FILE);
	# get the device name
	$dev = ((split(/\s+/,$dev))[2]);
	if (!$dev || $dev eq "") {
		# default to something non-destructive
		print STDERR "Could not establish device name for DUMP_TAPE${device}!\n";
		$dev = "/dev/null";
	}
	$dev;
}

sub BackupNonRewind {
	local($device) = @_;
	local($nonrewind);

	# give the name of the non-rewinding device.  Checks for existance
	#  based on r3, r4, and aix naming conventions
	undef $nonrewind;
	$nonrewind="tn" if (-e "${device}tn");
	$nonrewind="n" if (-e "${device}n");
	$nonrewind=".1" if (-e "${device}.1");
	warn "cannot find nonrewinding device for $device" if (!$nonrewind);
	$nonrewind;
}

sub Expand {
    &SetBACKBONES(@_);
    @BACKBONES;
}

# succuessfully loaded library
1;

